// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    /// <summary>
    /// SSL certificate information.
    /// </summary>
    public partial class CertificateInformation
    {
        private DateTime _expiry;
        
        /// <summary>
        /// Required. Gets or sets expiration date of the certificate.
        /// </summary>
        public DateTime Expiry
        {
            get { return this._expiry; }
            set { this._expiry = value; }
        }
        
        private string _subject;
        
        /// <summary>
        /// Required. Gets or sets subject of the certificate.
        /// </summary>
        public string Subject
        {
            get { return this._subject; }
            set { this._subject = value; }
        }
        
        private string _thumbprint;
        
        /// <summary>
        /// Required. Gets or sets thumbprint of the certificate.
        /// </summary>
        public string Thumbprint
        {
            get { return this._thumbprint; }
            set { this._thumbprint = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the CertificateInformation class.
        /// </summary>
        public CertificateInformation()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the CertificateInformation class with
        /// required arguments.
        /// </summary>
        public CertificateInformation(DateTime expiry, string thumbprint, string subject)
            : this()
        {
            if (thumbprint == null)
            {
                throw new ArgumentNullException("thumbprint");
            }
            if (subject == null)
            {
                throw new ArgumentNullException("subject");
            }
            this.Expiry = expiry;
            this.Thumbprint = thumbprint;
            this.Subject = subject;
        }
    }
}
