// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.Insights.Models;

namespace Microsoft.Azure.Management.Insights.Models
{
    /// <summary>
    /// Basic diagnostics configuration.
    /// </summary>
    public partial class DiagnosticMonitorConfiguration
    {
        private CrashDumps _crashDumps;
        
        /// <summary>
        /// Optional. Enable collection of crash dumps.
        /// </summary>
        public CrashDumps CrashDumps
        {
            get { return this._crashDumps; }
            set { this._crashDumps = value; }
        }
        
        private DiagnosticInfrastructureLogs _diagnosticInfrastructureLogs;
        
        /// <summary>
        /// Optional. Enable collection of logs generated by the agent. The
        /// diagnostic infrastructure logs are useful for troubleshooting the
        /// diagnostics system itself.
        /// </summary>
        public DiagnosticInfrastructureLogs DiagnosticInfrastructureLogs
        {
            get { return this._diagnosticInfrastructureLogs; }
            set { this._diagnosticInfrastructureLogs = value; }
        }
        
        private Directories _directories;
        
        /// <summary>
        /// Optional. Enable the collection of the contents of a directory, IIS
        /// failed access request logs and/or IIS logs.
        /// </summary>
        public Directories Directories
        {
            get { return this._directories; }
            set { this._directories = value; }
        }
        
        private EtwProviders _etwProviders;
        
        /// <summary>
        /// Optional. Configures collection of ETW events from EventSource
        /// and/or ETW Manifest based providers.
        /// </summary>
        public EtwProviders EtwProviders
        {
            get { return this._etwProviders; }
            set { this._etwProviders = value; }
        }
        
        private Metrics _metrics;
        
        /// <summary>
        /// Optional. This element enables you to generate a performance
        /// counter table that is optimized for fast queries. Each performance
        /// counter that is defined in the PerformanceCounters element is
        /// stored in the Metrics table in addition to the Performance Counter
        /// table.
        /// </summary>
        public Metrics Metrics
        {
            get { return this._metrics; }
            set { this._metrics = value; }
        }
        
        private int? _overallQuotaInMB;
        
        /// <summary>
        /// Optional. The maximum amount of local disk space that may be
        /// consumed by the various types of diagnostic data collected by the
        /// agent. The default setting is 5120MB.
        /// </summary>
        public int? OverallQuotaInMB
        {
            get { return this._overallQuotaInMB; }
            set { this._overallQuotaInMB = value; }
        }
        
        private PerformanceCounters _performanceCounters;
        
        /// <summary>
        /// Optional. Enable the collection of Performance Counters.
        /// </summary>
        public PerformanceCounters PerformanceCounters
        {
            get { return this._performanceCounters; }
            set { this._performanceCounters = value; }
        }
        
        private WindowsEventLog _windowsEventLog;
        
        /// <summary>
        /// Optional. Enable the collection of Windows Event Logs.
        /// </summary>
        public WindowsEventLog WindowsEventLog
        {
            get { return this._windowsEventLog; }
            set { this._windowsEventLog = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DiagnosticMonitorConfiguration
        /// class.
        /// </summary>
        public DiagnosticMonitorConfiguration()
        {
        }
    }
}
