// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Network.Models;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// Parameters supplied to the Start Public Diagnostics operation.
    /// </summary>
    public partial class StartGatewayPublicDiagnosticsParameters
    {
        private string _captureDurationInSeconds;
        
        /// <summary>
        /// Optional. The duration of the capture in seconds (between 1 and 300)
        /// </summary>
        public string CaptureDurationInSeconds
        {
            get { return this._captureDurationInSeconds; }
            set { this._captureDurationInSeconds = value; }
        }
        
        private string _containerName;
        
        /// <summary>
        /// Optional. The container name provided by customer (optional)
        /// </summary>
        public string ContainerName
        {
            get { return this._containerName; }
            set { this._containerName = value; }
        }
        
        private string _customerStorageKey;
        
        /// <summary>
        /// Optional. The customer's storage account key
        /// </summary>
        public string CustomerStorageKey
        {
            get { return this._customerStorageKey; }
            set { this._customerStorageKey = value; }
        }
        
        private string _customerStorageName;
        
        /// <summary>
        /// Optional. The customer's storage account name
        /// </summary>
        public string CustomerStorageName
        {
            get { return this._customerStorageName; }
            set { this._customerStorageName = value; }
        }
        
        private UpdateGatewayPublicDiagnosticsOperation _operation;
        
        /// <summary>
        /// Optional. The update gateway diagnostics operation to perform on
        /// the gateway tenant
        /// </summary>
        public UpdateGatewayPublicDiagnosticsOperation Operation
        {
            get { return this._operation; }
            set { this._operation = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// StartGatewayPublicDiagnosticsParameters class.
        /// </summary>
        public StartGatewayPublicDiagnosticsParameters()
        {
        }
    }
}
