// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Represents an individual Azure SQL Database Server.
    /// </summary>
    public partial class Server
    {
        private string _administratorUserName;
        
        /// <summary>
        /// Optional. Gets the administrator login for the server.
        /// </summary>
        public string AdministratorUserName
        {
            get { return this._administratorUserName; }
            set { this._administratorUserName = value; }
        }
        
        private string _fullyQualifiedDomainName;
        
        /// <summary>
        /// Optional. Gets the fully qualified domain name of the Azure SQL
        /// Database Server.
        /// </summary>
        public string FullyQualifiedDomainName
        {
            get { return this._fullyQualifiedDomainName; }
            set { this._fullyQualifiedDomainName = value; }
        }
        
        private string _location;
        
        /// <summary>
        /// Optional. Gets the location of this server. See
        /// http://azure.microsoft.com/en-us/regions/#services for a list of
        /// valid regions.
        /// </summary>
        public string Location
        {
            get { return this._location; }
            set { this._location = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets the name of the Azure SQL Database Server.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Gets the current state of the server.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Gets the version of the server.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the Server class.
        /// </summary>
        public Server()
        {
        }
    }
}
