// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class represents the base object for a backup schedule object -
    /// without id.
    /// </summary>
    public partial class BackupScheduleBase
    {
        private BackupType _backupType;
        
        /// <summary>
        /// Required. The type of the backup.
        /// </summary>
        public BackupType BackupType
        {
            get { return this._backupType; }
            set { this._backupType = value; }
        }
        
        private ScheduleRecurrence _recurrence;
        
        /// <summary>
        /// Required. The recurrence of this schedule.
        /// </summary>
        public ScheduleRecurrence Recurrence
        {
            get { return this._recurrence; }
            set { this._recurrence = value; }
        }
        
        private long _retentionCount;
        
        /// <summary>
        /// Required. Retention count for backups of this schedule.
        /// </summary>
        public long RetentionCount
        {
            get { return this._retentionCount; }
            set { this._retentionCount = value; }
        }
        
        private string _startTime;
        
        /// <summary>
        /// Required. The StartTime for this schedule.
        /// </summary>
        public string StartTime
        {
            get { return this._startTime; }
            set { this._startTime = value; }
        }
        
        private ScheduleStatus _status;
        
        /// <summary>
        /// Required. The status of the schedule
        /// </summary>
        public ScheduleStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BackupScheduleBase class.
        /// </summary>
        public BackupScheduleBase()
        {
        }
    }
}
