// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using System.Threading;
using System.Threading.Tasks;
using Microsoft.WindowsAzure.WebSitesExtensions;
using Microsoft.WindowsAzure.WebSitesExtensions.Models;

namespace Microsoft.WindowsAzure.WebSitesExtensions
{
    /// <summary>
    /// The websites extensions client manages the web sites deployments, web
    /// jobs and other extensions.
    /// </summary>
    public static partial class CommandsOperationsExtensions
    {
        /// <summary>
        /// Invoke a command on the website's VM.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.WebSitesExtensions.ICommandsOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. The invoke command parameters.
        /// </param>
        /// <returns>
        /// The invoke command operation response.
        /// </returns>
        public static InvokeCommandResponse Invoke(this ICommandsOperations operations, InvokeCommandParameters parameters)
        {
            return Task.Factory.StartNew((object s) => 
            {
                return ((ICommandsOperations)s).InvokeAsync(parameters);
            }
            , operations, CancellationToken.None, TaskCreationOptions.None, TaskScheduler.Default).Unwrap().GetAwaiter().GetResult();
        }
        
        /// <summary>
        /// Invoke a command on the website's VM.
        /// </summary>
        /// <param name='operations'>
        /// Reference to the
        /// Microsoft.WindowsAzure.WebSitesExtensions.ICommandsOperations.
        /// </param>
        /// <param name='parameters'>
        /// Required. The invoke command parameters.
        /// </param>
        /// <returns>
        /// The invoke command operation response.
        /// </returns>
        public static Task<InvokeCommandResponse> InvokeAsync(this ICommandsOperations operations, InvokeCommandParameters parameters)
        {
            return operations.InvokeAsync(parameters, CancellationToken.None);
        }
    }
}
